function Ajax(){
    this.xhr
    this.data
    this.init = function(){
        if(window.XMLHttpRequest){
            this.xhr=new XMLHttpRequest()
        }else{
            this.xhr=new ActiveXObject("Microsoft.XMLHTTP")
        }
        return this
    }
    this.before = function(func){
        this.xhr.addEventListener('readystatechange',function(){
            if(this.readyState < 4){
                func()
            }
        })
        return this
    }
    this.success = function(func){
        this.xhr.addEventListener('readystatechange',function(){
            if (this.readyState == 4 && this.status == 200){
                var res
                if(this.getResponseHeader('content-type')==='application/json'){
                    res = JSON.parse(this.responseText)
                }else{
                    res = this.responseText
                }
                func(res)
            }
        })
        return this
    }
    this.error = function(func){
        this.xhr.addEventListener('readystatechange',function(){
            if(this.readyState == 4 && this.status != 200){
                func()
            }
        })
        return this
    }
    this.request = function(obj){
        this.data = obj.data
        var url = obj.url
        var type = obj.type
        var async = obj.async
        var json = (obj.json===true)?true:false
        var auth = obj.auth
        this.init()
        this.xhr.open(type,url,async)
        if(json){
            this.xhr.setRequestHeader("Content-type", "application/json")
            this.data = JSON.stringify(this.data)
        }else{
            this.xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
        }
        if(auth){
            this.xhr.withCredentials = true
            this.xhr.setRequestHeader("Authorization", "Basic " + btoa(auth))
        }
        return this
    }
    this.send = function(){
        this.xhr.send(this.data)
    }
}
module.exports = Ajax